diff --git a/java/yb-pgsql/src/test/java/org/yb/pgsql/TestPgRegressCursor.java b/java/yb-pgsql/src/test/java/org/yb/pgsql/TestPgRegressCursor.java
index e331986138ce..067ac276a469 100644
--- a/java/yb-pgsql/src/test/java/org/yb/pgsql/TestPgRegressCursor.java
+++ b/java/yb-pgsql/src/test/java/org/yb/pgsql/TestPgRegressCursor.java
@@ -17,6 +17,7 @@
 import static org.yb.util.BuildTypeUtil.isTSAN;
 
 import java.sql.*;
+import java.util.Collections;
 
 import org.junit.Test;
 import org.junit.runner.RunWith;
@@ -128,4 +129,12 @@ public void testPgRegressCursor() throws Exception {
     // Test CURSOR in JDBC.
     runTestCursor();
   }
+
+  @Test
+  public void testPgRegressCursorLowPrefetching() throws Exception {
+    markClusterNeedsRecreation();
+    restartClusterWithFlags(
+        Collections.emptyMap(), Collections.singletonMap("ysql_prefetch_limit", "1"));
+    runPgRegressTest("yb_cursor_low_prefetching_schedule");
+  }
 }
diff --git a/src/postgres/src/backend/access/yb_access/yb_scan.c b/src/postgres/src/backend/access/yb_access/yb_scan.c
index cd70907093f8..bec2bb2f9a4f 100644
--- a/src/postgres/src/backend/access/yb_access/yb_scan.c
+++ b/src/postgres/src/backend/access/yb_access/yb_scan.c
@@ -2258,7 +2258,8 @@ YBCLockTuple(Relation relation, Datum ybctid, RowMarkType mode, LockWaitPolicy w
 	exec_params.limit_count = 1;
 	exec_params.rowmark = mode;
 	exec_params.wait_policy = wait_policy;
-  exec_params.statement_in_txn_limit = estate->yb_exec_params.statement_in_txn_limit;
+  exec_params.stmt_in_txn_limit_ht_for_reads =
+		estate->yb_exec_params.stmt_in_txn_limit_ht_for_reads;
 
 	HTSU_Result res = HeapTupleMayBeUpdated;
 	MemoryContext exec_context = GetCurrentMemoryContext();
diff --git a/src/postgres/src/backend/executor/execUtils.c b/src/postgres/src/backend/executor/execUtils.c
index 4b6eac53b42f..fbbd57c58279 100644
--- a/src/postgres/src/backend/executor/execUtils.c
+++ b/src/postgres/src/backend/executor/execUtils.c
@@ -173,27 +173,27 @@ CreateExecutorState(void)
 	estate->yb_es_is_single_row_modify_txn = false;
 	estate->yb_es_is_fk_check_disabled = false;
 	estate->yb_conflict_slot = NULL;
-	/*
-	 * The in txn limit used for this query. This will be initialized by the first
-	 * read operation invoked for this query, and all later reads performed by
-	 * this query will not read any data written past this time.
-	 *
-	 * TODO: Each query can have multiple "EState"s. Fix logic for such cases.
-	 */
-	estate->yb_es_in_txn_limit_ht = 0;
+	estate->yb_es_in_txn_limit_ht_for_reads = 0;
 
 	estate->yb_exec_params.limit_count = 0;
 	estate->yb_exec_params.limit_offset = 0;
 	estate->yb_exec_params.limit_use_default = true;
 	estate->yb_exec_params.rowmark = -1;
 	estate->yb_exec_params.is_index_backfill = false;
+
 	/*
-	 * Pointer to the query's in txn limit. This pointer is passed
-	 * down to all the DocDB read operations invoked for this query. Only
-	 * the first read operation initializes its value, and all the other
-	 * operations ensure that they don't read any value written past this time.
+	 * Pointer to the query's in_txn_limit_ht for read ops. This pointer is passed
+	 * down via PgDocOp instances to the DocDB read operations invoked for this
+	 * query. Only the first read operation initializes its value, and all the
+	 * other operations ensure that they don't read any value written past this
+	 * time.
+	 *
+	 * TODO(#16239): Each SQL statement can have multiple "EState"s. But we need
+	 * to ensure that only one in_txn_limit_ht is used for reads in one SQL
+	 * statement. Fix logic for such cases.
 	 */
-	estate->yb_exec_params.statement_in_txn_limit = &estate->yb_es_in_txn_limit_ht;
+	estate->yb_exec_params.stmt_in_txn_limit_ht_for_reads =
+		&estate->yb_es_in_txn_limit_ht_for_reads;
 
 	return estate;
 }
diff --git a/src/postgres/src/include/nodes/execnodes.h b/src/postgres/src/include/nodes/execnodes.h
index 6bb218552dae..3cd48d31ac35 100644
--- a/src/postgres/src/include/nodes/execnodes.h
+++ b/src/postgres/src/include/nodes/execnodes.h
@@ -593,12 +593,21 @@ typedef struct EState
 	YBCPgExecParameters yb_exec_params;
 
 	/*
-	 *  The in txn limit used for this query. This value is initialized
-	 *  to 0, and later updated by the first read operation initiated for this
-	 *  query. All later read operations are then ensured that they will never
-	 *  read any data written past this time.
+	 * The in_txn_limit used by all reads executed by this executor state. This is done to satisfy
+	 * requirement 1 in src/yb/yql/pggate/README i.e., all reads of a SQL statement should use the
+	 * same in_txn_limit. A pointer to this is passed down via PgExecParameters to all PgDocOp
+	 * instances invoked by the SQL statement. The first read operation by the statement finds that
+	 * this is unset i.e., 0 and hence initializes the in txn limit for read operations. All future
+	 * operations see this to be non-zero and hence don't change the picked in txn limit for reads.
+	 *
+	 * So, all read operations in the statement use the txn limit picked on the first read op of the
+	 * statement.
+	 *
+	 * NOTE: This is slightly incorrect and causes a bug as explained in requirement 1 of
+	 * src/yb/yql/pggate/README. But apart from that corner case, this ensures that read operations of
+	 * a SQL statement don't read any value written by the same statement.
 	 */
-	uint64_t yb_es_in_txn_limit_ht;
+	uint64_t yb_es_in_txn_limit_ht_for_reads;
 } EState;
 
 /*
diff --git a/src/postgres/src/test/regress/expected/yb_cursor_preserve_in_txn_limit.out b/src/postgres/src/test/regress/expected/yb_cursor_preserve_in_txn_limit.out
new file mode 100644
index 000000000000..394de895d033
--- /dev/null
+++ b/src/postgres/src/test/regress/expected/yb_cursor_preserve_in_txn_limit.out
@@ -0,0 +1,40 @@
+-- Test to ensure that the same in_txn_limit_ht is used for all FETCHes on a cursor. See
+-- ReadHybridTime for information about in_txn_limit_ht.
+--
+-- An in_txn_limit_ht will be picked on the first FETCH performed by a cursor. The same should be
+-- used for all future FETCHes on the cursor. This ensures that any data written by the same
+-- transaction after the first FETCH isn't visible to the future FETCHes.
+--
+-- NOTE: a low ysql_prefetch_limit is needed to ensure the test is reliable i.e., it should fail if
+-- the second FETCH doesn't use the same in_txn_limit as the first one. If the ysql_prefetch_limit
+-- is higher than the table size, the first FETCH would end up marking the cursor scan as completed
+-- and hence return no rows in the second FETCH even if a new in_txn_limit was to be used.
+CREATE TABLE t1(k INT, PRIMARY KEY(k ASC)) SPLIT AT VALUES((2));
+INSERT INTO t1 SELECT i FROM generate_series(1, 2) AS i;
+BEGIN;
+DECLARE c1 SCROLL CURSOR FOR SELECT * FROM t1;
+INSERT INTO t1 VALUES(3); -- rows inserted before the first FETCH will be visible
+INSERT INTO t1 VALUES(4);
+FETCH 1 FROM c1;
+ k
+---
+ 1
+(1 row)
+
+INSERT INTO t1 VALUES(5); -- rows inserted after the first FETCH should not be visible
+INSERT INTO t1 VALUES(6);
+SELECT count(*) FROM t1; -- this statement uses a new in_txn_limit and hence sees all rows
+ count
+-------
+     6
+(1 row)
+
+FETCH 10 FROM c1;
+ k
+---
+ 2
+ 3
+ 4
+(3 rows)
+
+ROLLBACK;
\ No newline at end of file
diff --git a/src/postgres/src/test/regress/expected/yb_query_consistent_snapshot.out b/src/postgres/src/test/regress/expected/yb_query_consistent_snapshot.out
index 7a2eed9b6547..0f797499c267 100644
--- a/src/postgres/src/test/regress/expected/yb_query_consistent_snapshot.out
+++ b/src/postgres/src/test/regress/expected/yb_query_consistent_snapshot.out
@@ -1,4 +1,4 @@
--- Verify that SELECTs of a single query are on a single read point.
+-- Verify that SELECTs of a single query don't read data written by the same SQL query.
 CREATE table test1(id int primary key, value int);
 CREATE table test2(id int primary key, value int);
 INSERT INTO test1 VALUES(1, 1);
@@ -165,3 +165,13 @@ SELECT * FROM test2 ORDER BY id;
  14 |     1
  15 |     1
 (13 rows)
+
+-- The below test case is for gh issue #10142. As part of this bug, if a write was performed before the first
+-- read of the SQL statement, the write would be visible to the read. This was because the in_txn_limit (see
+-- ReadHybridTimePB for details) for the reads of the SQL statement was being picked on the first read op
+-- issued by the statement and not at the first op (which was a write in this case).
+--
+-- TODO: Uncomment this once the TODO in PgDocOp::SendRequestImpl is fixed.
+-- create table test_no_pk (v int);
+-- with ins AS (insert into test_no_pk values (5) returning *) select * from test_no_pk, ins; -- should return 0 rows
+-- select * from test_no_pk;
\ No newline at end of file
diff --git a/src/postgres/src/test/regress/sql/yb_cursor_preserve_in_txn_limit.sql b/src/postgres/src/test/regress/sql/yb_cursor_preserve_in_txn_limit.sql
new file mode 100644
index 000000000000..48704bb37edb
--- /dev/null
+++ b/src/postgres/src/test/regress/sql/yb_cursor_preserve_in_txn_limit.sql
@@ -0,0 +1,24 @@
+-- Test to ensure that the same in_txn_limit_ht is used for all FETCHes on a cursor. See
+-- ReadHybridTime for information about in_txn_limit_ht.
+--
+-- An in_txn_limit_ht will be picked on the first FETCH performed by a cursor. The same should be
+-- used for all future FETCHes on the cursor. This ensures that any data written by the same
+-- transaction after the first FETCH isn't visible to the future FETCHes.
+--
+-- NOTE: a low ysql_prefetch_limit is needed to ensure the test is reliable i.e., it should fail if
+-- the second FETCH doesn't use the same in_txn_limit as the first one. If the ysql_prefetch_limit
+-- is higher than the table size, the first FETCH would end up marking the cursor scan as completed
+-- and hence return no rows in the second FETCH even if a new in_txn_limit was to be used.
+
+CREATE TABLE t1(k INT, PRIMARY KEY(k ASC)) SPLIT AT VALUES((2));
+INSERT INTO t1 SELECT i FROM generate_series(1, 2) AS i;
+BEGIN;
+DECLARE c1 SCROLL CURSOR FOR SELECT * FROM t1;
+INSERT INTO t1 VALUES(3); -- rows inserted before the first FETCH will be visible
+INSERT INTO t1 VALUES(4);
+FETCH 1 FROM c1;
+INSERT INTO t1 VALUES(5); -- rows inserted after the first FETCH should not be visible
+INSERT INTO t1 VALUES(6);
+SELECT count(*) FROM t1; -- this statement uses a new in_txn_limit and hence sees all rows
+FETCH 10 FROM c1;
+ROLLBACK;
\ No newline at end of file
diff --git a/src/postgres/src/test/regress/sql/yb_query_consistent_snapshot.sql b/src/postgres/src/test/regress/sql/yb_query_consistent_snapshot.sql
index 3f1e3af0c2d8..749dd49d982f 100644
--- a/src/postgres/src/test/regress/sql/yb_query_consistent_snapshot.sql
+++ b/src/postgres/src/test/regress/sql/yb_query_consistent_snapshot.sql
@@ -1,4 +1,4 @@
--- Verify that SELECTs of a single query are on a single read point.
+-- Verify that SELECTs of a single query don't read data written by the same SQL query.
 CREATE table test1(id int primary key, value int);
 CREATE table test2(id int primary key, value int);
 INSERT INTO test1 VALUES(1, 1);
@@ -48,3 +48,13 @@ $$;
 
 CALL testproc();
 SELECT * FROM test2 ORDER BY id;
+
+-- The below test case is for gh issue #10142. As part of this bug, if a write was performed before the first
+-- read of the SQL statement, the write would be visible to the read. This was because the in_txn_limit (see
+-- ReadHybridTimePB for details) for the reads of the SQL statement was being picked on the first read op
+-- issued by the statement and not at the first op (which was a write in this case).
+--
+-- TODO: Uncomment this once the TODO in PgDocOp::SendRequestImpl is fixed.
+-- create table test_no_pk (v int);
+-- with ins AS (insert into test_no_pk values (5) returning *) select * from test_no_pk, ins; -- should return 0 rows
+-- select * from test_no_pk;
\ No newline at end of file
diff --git a/src/postgres/src/test/regress/yb_cursor_low_prefetching_schedule b/src/postgres/src/test/regress/yb_cursor_low_prefetching_schedule
new file mode 100644
index 000000000000..c65f3f6ea734
--- /dev/null
+++ b/src/postgres/src/test/regress/yb_cursor_low_prefetching_schedule
@@ -0,0 +1,6 @@
+# src/test/regress/yb_cursor_low_prefetching_schedule
+#
+####################################################################################################
+# This suite includes tests on CURSOR with low prefetching.
+####################################################################################################
+test: yb_cursor_preserve_in_txn_limit
diff --git a/src/yb/common/common.proto b/src/yb/common/common.proto
index 1c6545522153..b897cd110947 100644
--- a/src/yb/common/common.proto
+++ b/src/yb/common/common.proto
@@ -373,6 +373,16 @@ message ReadHybridTimePB {
 
   optional fixed64 global_limit_ht = 3;
 
+  // When a transaction reads data, all committed writes of other transactions with a timestamp
+  // <= read_ht are visible.
+  //
+  // However, a transaction's reads should be able to see all provisional writes from the same
+  // transaction irrespective of read_ht, except some based on additional constraints for YSQL (as
+  // described in src/yb/yql/pggate/README). The query layer uses in_txn_limit_ht to meet these
+  // constraints. If in_txn_limit_ht is set, any operation will not be able to read provisional
+  // writes from the same transaction which have a write timestamp higher than the in_txn_limit_ht.
+  //
+  // src/yb/yql/pggate/README also explains how this works along with YSQL's buffering logic.
   optional fixed64 in_txn_limit_ht = 4;
 
   optional fixed64 local_limit_ht = 5;
diff --git a/src/yb/tserver/pg_client.proto b/src/yb/tserver/pg_client.proto
index b3e90291b76f..e0afbd314bcf 100644
--- a/src/yb/tserver/pg_client.proto
+++ b/src/yb/tserver/pg_client.proto
@@ -356,13 +356,21 @@ enum ReadTimeManipulation {
   RESTART = 2;
 }
 
+// TODO: Remove the OptionalUint32PB helper message after updating protobuf generator to allow
+// 'optional' in proto3
+message OptionalFixed64PB {
+  fixed64 value = 1;
+}
+
 message PgPerformOptionsPB {
   // Cannot use IsolationLevel enum, since we cannot use proto2 enum in proto3 messages.
   // Replace with IsolationLevel after migration to proto3.
   uint32 isolation = 2;
   bool ddl_mode = 3;
   uint64 txn_serial_no = 4;
-  fixed64 in_txn_limit_ht = 5;
+
+  // See ReadHybridTimePB for information about in_txn_limit_ht.
+  OptionalFixed64PB in_txn_limit_ht = 5;
   bool use_existing_priority = 6;
   fixed64 priority = 7;
   bool restart_transaction = 8;
@@ -384,6 +392,7 @@ message PgPerformResponsePB {
   AppStatusPB status = 1;
   repeated PgsqlResponsePB responses = 2;
   ReadHybridTimePB catalog_read_time = 3;
+  fixed64 used_in_txn_limit_ht = 4;
 }
 
 message PgReserveOidsRequestPB {
diff --git a/src/yb/tserver/pg_client_session.cc b/src/yb/tserver/pg_client_session.cc
index 67946d748630..57ec02e606ec 100644
--- a/src/yb/tserver/pg_client_session.cc
+++ b/src/yb/tserver/pg_client_session.cc
@@ -303,6 +303,7 @@ struct PerformData {
   PgClientSessionOperations ops;
   PgTableCache* table_cache;
   PgClientSession::UsedReadTimePtr used_read_time;
+  HybridTime used_in_txn_limit;
 
   void FlushDone(client::FlushStatus* flush_status) {
     auto status = CombineErrorsToStatus(flush_status->errors, flush_status->status);
@@ -344,6 +345,9 @@ struct PerformData {
       }
       op_resp.set_partition_list_version(op->table()->GetPartitionListVersion());
     }
+    if (used_in_txn_limit) {
+      resp->set_used_in_txn_limit_ht(used_in_txn_limit.ToUint64());
+    }
 
     return Status::OK();
   }
@@ -357,6 +361,14 @@ client::YBSessionPtr CreateSession(
   return result;
 }
 
+HybridTime GetInTxnLimit(const PgPerformOptionsPB& options, ClockBase* clock) {
+  if (!options.has_in_txn_limit_ht()) {
+    return HybridTime();
+  }
+  auto in_txn_limit = HybridTime::FromPB(options.in_txn_limit_ht().value());
+  return in_txn_limit ? in_txn_limit : clock->Now();
+}
+
 } // namespace
 
 PgClientSession::PgClientSession(
@@ -584,7 +596,10 @@ Status PgClientSession::FinishTransaction(
 
 Status PgClientSession::Perform(
     const PgPerformRequestPB& req, PgPerformResponsePB* resp, rpc::RpcContext* context) {
-  auto session_info = VERIFY_RESULT(SetupSession(req, context->GetClientDeadline()));
+  VLOG_WITH_PREFIX(5) << "Perform req=" << req.ShortDebugString();
+  const auto in_txn_limit = GetInTxnLimit(req.options(), clock_.get());
+  VLOG_WITH_PREFIX(5) << "using in_txn_limit_ht: " << in_txn_limit;
+  auto session_info = VERIFY_RESULT(SetupSession(req, context->GetClientDeadline(), in_txn_limit));
   auto* session = session_info.first;
   auto ops = VERIFY_RESULT(PrepareOperations(req, session, &table_cache_));
   auto data = std::make_shared<PerformData>(PerformData {
@@ -594,7 +609,8 @@ Status PgClientSession::Perform(
     .context = std::move(*context),
     .ops = std::move(ops),
     .table_cache = &table_cache_,
-    .used_read_time = session_info.second
+    .used_read_time = session_info.second,
+    .used_in_txn_limit = in_txn_limit
   });
   session->FlushAsync([data](client::FlushStatus* flush_status) {
     data->FlushDone(flush_status);
@@ -629,7 +645,8 @@ void PgClientSession::ProcessReadTimeManipulation(ReadTimeManipulation manipulat
 }
 
 Result<std::pair<client::YBSession*, PgClientSession::UsedReadTimePtr>>
-PgClientSession::SetupSession(const PgPerformRequestPB& req, CoarseTimePoint deadline) {
+PgClientSession::SetupSession(
+    const PgPerformRequestPB& req, CoarseTimePoint deadline, HybridTime in_txn_limit) {
   const auto& options = req.options();
   PgClientSessionKind kind;
   if (options.use_catalog_session()) {
@@ -696,12 +713,12 @@ PgClientSession::SetupSession(const PgPerformRequestPB& req, CoarseTimePoint dea
     session->DeferReadPoint();
   }
 
+  // TODO: Reset in_txn_limit which might be on session from past Perform? Not resetting will not
+  // cause any issue, but should we reset for safety?
   if (!options.ddl_mode() && !options.use_catalog_session()) {
     txn_serial_no_ = options.txn_serial_no();
-
-    const auto in_txn_limit = HybridTime::FromPB(options.in_txn_limit_ht());
     if (in_txn_limit) {
-      VLOG_WITH_PREFIX(3) << "In txn limit: " << in_txn_limit;
+      // TODO: Shouldn't the below logic for DDL transactions as well?
       session->SetInTxnLimit(in_txn_limit);
     }
   }
diff --git a/src/yb/tserver/pg_client_session.h b/src/yb/tserver/pg_client_session.h
index 193948fba1c0..85f4137ad0a7 100644
--- a/src/yb/tserver/pg_client_session.h
+++ b/src/yb/tserver/pg_client_session.h
@@ -107,7 +107,7 @@ class PgClientSession : public std::enable_shared_from_this<PgClientSession> {
       client::YBSession* session, client::YBTransaction* transaction);
 
   Result<std::pair<client::YBSession*, UsedReadTimePtr>> SetupSession(
-      const PgPerformRequestPB& req, CoarseTimePoint deadline);
+      const PgPerformRequestPB& req, CoarseTimePoint deadline, HybridTime in_txn_limit);
   Status ProcessResponse(
       const PgClientSessionOperations& operations, const PgPerformRequestPB& req,
       PgPerformResponsePB* resp, rpc::RpcContext* context);
diff --git a/src/yb/yql/pggate/README b/src/yb/yql/pggate/README
new file mode 100644
index 000000000000..8e2eb1385425
--- /dev/null
+++ b/src/yb/yql/pggate/README
@@ -0,0 +1,127 @@
+Buffering in YSQL
+-----------------
+
+Allowing the YSQL execution engine to make progress without waiting for the
+actual work to be done on the tablet servers (via rpcs) helps batch multiple
+operations in one rpc. This allows lesser consumption of resources and reduces
+overall latency when one operation doesn't have to wait for another to complete.
+Also, asynchronously flushing buffers while YSQL performs local work can help
+reduce latency further (for example, in case of COPY command). For these reasons,
+YSQL uses buffering as much as possible with various constraints to ensure
+correctness.
+
+Requirements
+------------
+
+While delaying actual work using buffering can give various performance gains,
+YSQL has the following constraints to ensure correctness:
+
+1) Read ops from a SQL statement should not be able to see writes done as part of the same
+statement. This is required to ensure that statements like
+"INSERT INTO table VALUES SELECT ... FROM table" don't end up in an endless cycle of reading
+what they wrote to write more data.
+
+2) A write op might also under the hood read some data in docdb.
+   a) It should not be able to see writes done as part of the same op.
+   b) However, it should be able to see writes done as part of previous ops in the same
+      transaction (could also be ops part of the same statment, unlike the requirement for read
+      ops).
+
+The query layer uses in_txn_limit_ht (see ReadHybridTimePB) to provide the tserver with necessary
+information to achieve (1) & (2). If in_txn_limit_ht is set, any operation will not be able to read
+provisional writes from the same transaction which have a write timestamp higher than the
+in_txn_limit_ht.
+
+YSQL achieves requirements (1) & (2) as follows:
+
+1) For each new SQL statement, the current hybrid time is picked as the in_txn_limit which is
+used for all reads that will be performed as part of that statement. This in_txn_limit is picked
+on the PgClientService of the tserver/ master process of the same node where the YSQL backend
+resides (i.e., the proxy used by the YSQL backend to reach other nodes in the cluster). Also, any
+write from a previous SQL statement that a read is supposed to see, should have completed before the
+in_txn_limit is picked; so that the write timestamp of that write is lower than the in_txn_limit of
+the read. (See PgSession::RunHelper::Apply() where this is ensured)
+
+TODO: the in_txn_limit for reads is picked on the first read operation/ first non-buffered write
+operation of the SQL statement. However, there could be some buffered write operations as part of
+the same SQL statmeent before the first read op and hence they become visible to the reads of the
+statement.
+
+This causes bug #10142 (as commented out in the yb_query_consistent_snapshot regress test) as
+follows: the buffered write ops due to the INSERT are done first. And the in_txn_limit_ht for reads
+for the SQL statement is picked later. This causes the SELECT to see the writes from the INSERT.
+
+Fixing this bug is not easy because RI_FKey_restrict_upd() requires that the read op sees the write
+done as part of the same SQL statement.
+
+2)
+
+a) Every batch of writes pick the current hybrid time as the in_txn_limit before any execution. So,
+a write op won't be able to see its own writes. (See PgClientSession::Perform() where this is
+ensured)
+
+b) A write op should be able to read data from previous writes to the same row. So if 2 ops change
+the same row one after the other, the one which came in later should see the modification by the
+earlier write op. Given this, the query layer does the following to ensure all later writes see
+modification of earlier writes:
+
+   i) Ensures that no batch of writes has 2 writes to the same row. (See
+   PgOperationBuffer::Impl::DoAdd() where this is ensured)
+
+   ii) Since every batch of writes picks the current hybrid time as the in_txn_limit, if 2 batches
+   of writes touch the same row, the later batch will pick an in_txn_limit only after the earlier
+   batch is done. This ensures that the write timestamp of any write in the earlier batch is lower
+   than the in_txn_limit picked by the later batch.
+
+Given the above, this is how writes and reads are buffered and flushed:
+
+1) Writes:
+
+Writes from multiple SQL statements can be buffered until future operations don't depend on the
+result of the writes. The statements that buffered writes can make progress assuming the writes were
+successful. This can be done because if an error in a buffered write is seen late during execution,
+it would anyway rollback the whole ongoing transaction and void any processing that occurred from
+SQL statements after the write.
+
+Writes are buffered in PgSession::buffer_. This buffer can possibly store writes of multiple
+SQL statements of the same transaction before flushing. Reads can't be buffered in
+PgSession::buffer_.
+
+A flush can happen either if the buffer is full or if later execution depends on the result of the
+writes or requires them to complete before making progress. The following scenarios should be
+handled:
+
+  1) There is a write op to the same row. Flush to satisfy requirement 2b).
+  2) A read op is being performed. Reads should be able to see the modifications done by
+     writes from previous statements.
+  3) The query engine explicitly flushes. This could happen because:
+
+      a) the TRY block in a TRY CATCH is ending and we better catch any exception from buffered ops
+      b) beginning or releasing a sub-transaction i.e., savepoint (see 373c476d)
+      c) in functions/ procedures, a statement with possible non-transactional side-effects
+         is going to be executed (see d46e18cc)
+      d) before each new statement in READ COMMITTED isolation
+      e) committing a transaction
+      f) entering/ exiting separate DDL transaction mode
+      g) when the outer most standard_ExecutorFinish is done (i.e., not a nested executor). This
+         usually happens when the topmost i.e., outer-level SQL statement is done executing. For
+         example, in case of a call to a PL/pgsql function, that is the outer SQL statement and all
+         SQL statements in the function result in nested execution.
+      h) COPY command (see 5e1a3dc5)
+
+Buffering has 2 session level configurables: ysql_session_max_batch_size and ysql_max_in_flight_ops.
+See guc.c to understand what they do.
+
+NOTE: in case the buffer is flushed just because ysql_session_max_batch_size was reached, YSQL
+will not wait for the response of the flushed operations. Instead it will track those as in-flight
+operations and perform error-handling for those later when required. This helps improve latency of
+situations like the COPY command where the YSQL execution engine doesn't have to block on in-flight
+writes and can instead read the local file for buffering further writes while the flushed writes
+are being completed on the TServer. See ad4a9914 for detailed summary.
+
+In other cases when the buffer is flushed due to a dependency, a response to the flushed operations
+will be waited upon before making progress.
+
+2) Reads:
+  These aren't buffered because usually the output of a read is required to make progress in the
+  query layer.
diff --git a/src/yb/yql/pggate/pg_client.cc b/src/yb/yql/pggate/pg_client.cc
index e5798d62accb..3b6ed1edb49a 100644
--- a/src/yb/yql/pggate/pg_client.cc
+++ b/src/yb/yql/pggate/pg_client.cc
@@ -382,8 +382,11 @@ class PgClient::Impl {
       if (result.status.ok()) {
         result.status = data->Process();
       }
-      if (result.status.ok() && data->resp.has_catalog_read_time()) {
-        result.catalog_read_time = ReadHybridTime::FromPB(data->resp.catalog_read_time());
+      if (result.status.ok()) {
+        if (data->resp.has_catalog_read_time()) {
+          result.catalog_read_time = ReadHybridTime::FromPB(data->resp.catalog_read_time());
+        }
+        result.used_in_txn_limit = HybridTime::FromPB(data->resp.used_in_txn_limit_ht());
       }
       data->callback(result);
     });
diff --git a/src/yb/yql/pggate/pg_client.h b/src/yb/yql/pggate/pg_client.h
index 956df3a15753..38c4a7084a73 100644
--- a/src/yb/yql/pggate/pg_client.h
+++ b/src/yb/yql/pggate/pg_client.h
@@ -52,9 +52,10 @@ struct PerformResult {
   Status status;
   ReadHybridTime catalog_read_time;
   rpc::CallResponsePtr response;
+  HybridTime used_in_txn_limit;
 
   std::string ToString() const {
-    return YB_STRUCT_TO_STRING(status, catalog_read_time);
+    return YB_STRUCT_TO_STRING(status, catalog_read_time, used_in_txn_limit);
   }
 };
 
diff --git a/src/yb/yql/pggate/pg_doc_op.cc b/src/yb/yql/pggate/pg_doc_op.cc
index 8a8742146f32..b5216a096f67 100644
--- a/src/yb/yql/pggate/pg_doc_op.cc
+++ b/src/yb/yql/pggate/pg_doc_op.cc
@@ -196,22 +196,21 @@ Status PgDocResult::ProcessSparseSystemColumns(std::string *reservoir) {
 
 //--------------------------------------------------------------------------------------------------
 
-PgDocResponse::PgDocResponse(PerformFuture future, uint64_t in_txn_limit)
-    : holder_(PerformInfo{.future = std::move(future), .in_txn_limit = in_txn_limit}) {}
+PgDocResponse::PgDocResponse(PerformFuture future)
+    : holder_(std::move(future)) {}
 
 PgDocResponse::PgDocResponse(ProviderPtr provider)
     : holder_(std::move(provider)) {}
 
 bool PgDocResponse::Valid() const {
-  return std::holds_alternative<PerformInfo>(holder_)
-      ? std::get<PerformInfo>(holder_).future.Valid()
+  return std::holds_alternative<PerformFuture>(holder_)
+      ? std::get<PerformFuture>(holder_).Valid()
       : static_cast<bool>(std::get<ProviderPtr>(holder_));
 }
 
 Result<PgDocResponse::Data> PgDocResponse::Get() {
-  if (std::holds_alternative<PerformInfo>(holder_)) {
-    auto& info = std::get<PerformInfo>(holder_);
-    return Data(VERIFY_RESULT(info.future.Get()), info.in_txn_limit);
+  if (std::holds_alternative<PerformFuture>(holder_)) {
+    return std::get<PerformFuture>(holder_).Get();
   }
   // Detach provider pointer after first usage to make PgDocResponse::Valid return false.
   ProviderPtr provider;
@@ -356,8 +355,8 @@ Status PgDocOp::SendRequestImpl(bool force_non_bufferable) {
   // Send at most "parallelism_level_" number of requests at one time.
   size_t send_count = std::min(parallelism_level_, active_op_count_);
   response_ = VERIFY_RESULT(sender_(
-      pg_session_.get(), pgsql_ops_.data(), send_count,
-      *table_, GetInTxnLimit(), force_non_bufferable));
+      pg_session_.get(), pgsql_ops_.data(), send_count, *table_,
+      HybridTime::FromPB(GetInTxnLimitHt()), force_non_bufferable));
   return Status::OK();
 }
 
@@ -381,7 +380,12 @@ Result<std::list<PgDocResult>> PgDocOp::ProcessResponseImpl(
   }
   const auto& data = *response;
   auto result = VERIFY_RESULT(ProcessCallResponse(*data.response));
-  GetInTxnLimit() = data.in_txn_limit;
+
+  if (data.used_in_txn_limit) {
+    VLOG(5) << "Received used_in_txn_limit_ht in resp=" << data.used_in_txn_limit
+            << ", existing in_txn_limit_ht: " << GetInTxnLimitHt();
+    GetInTxnLimitHt() = data.used_in_txn_limit.ToUint64();
+  }
   RETURN_NOT_OK(CompleteProcessResponse());
   return result;
 }
@@ -450,9 +454,10 @@ Result<std::list<PgDocResult>> PgDocOp::ProcessCallResponse(const rpc::CallRespo
   return result;
 }
 
-uint64_t& PgDocOp::GetInTxnLimit() {
-  return exec_params_.statement_in_txn_limit ? *exec_params_.statement_in_txn_limit
-                                             : in_txn_limit_;
+uint64_t& PgDocOp::GetInTxnLimitHt() {
+  return !IsWrite() && exec_params_.stmt_in_txn_limit_ht_for_reads
+      ? *exec_params_.stmt_in_txn_limit_ht_for_reads
+      : in_txn_limit_ht_;
 }
 
 Status PgDocOp::CreateRequests() {
@@ -479,10 +484,9 @@ Status PgDocOp::CompleteRequests() {
 
 Result<PgDocResponse> PgDocOp::DefaultSender(
     PgSession* session, const PgsqlOpPtr* ops, size_t ops_count, const PgTableDesc& table,
-    uint64_t in_txn_limit, bool force_non_bufferable) {
-  auto result = VERIFY_RESULT(session->RunAsync(
-      ops, ops_count, table, &in_txn_limit, force_non_bufferable));
-  return PgDocResponse(std::move(result), in_txn_limit);
+    HybridTime in_txn_limit, bool force_non_bufferable) {
+  return PgDocResponse(VERIFY_RESULT(session->RunAsync(
+      ops, ops_count, table, in_txn_limit, force_non_bufferable)));
 }
 
 //-------------------------------------------------------------------------------------------------
diff --git a/src/yb/yql/pggate/pg_doc_op.h b/src/yb/yql/pggate/pg_doc_op.h
index 2ac953e106fb..97c8a26b217a 100644
--- a/src/yb/yql/pggate/pg_doc_op.h
+++ b/src/yb/yql/pggate/pg_doc_op.h
@@ -21,6 +21,8 @@
 
 #include "yb/client/yb_op.h"
 
+#include "yb/common/hybrid_time.h"
+
 #include "yb/util/locks.h"
 #include "yb/util/lw_function.h"
 
@@ -211,13 +213,7 @@ class PgDocResult {
 // No memory allocations is required in case of using PerformFuture.
 class PgDocResponse {
  public:
-  struct Data {
-    Data(const rpc::CallResponsePtr& response_, uint64_t in_txn_limit_)
-        : response(response_), in_txn_limit(in_txn_limit_) {
-    }
-    rpc::CallResponsePtr response;
-    uint64_t in_txn_limit;
-  };
+  using Data = PerformFuture::Data;
 
   class Provider {
    public:
@@ -228,18 +224,14 @@ class PgDocResponse {
   using ProviderPtr = std::unique_ptr<Provider>;
 
   PgDocResponse() = default;
-  PgDocResponse(PerformFuture future, uint64_t in_txn_limit);
+  explicit PgDocResponse(PerformFuture future);
   explicit PgDocResponse(ProviderPtr provider);
 
   bool Valid() const;
   Result<Data> Get();
 
  private:
-  struct PerformInfo {
-    PerformFuture future;
-    uint64_t in_txn_limit;
-  };
-  std::variant<PerformInfo, ProviderPtr> holder_;
+  std::variant<PerformFuture, ProviderPtr> holder_;
 };
 
 class PgDocOp : public std::enable_shared_from_this<PgDocOp> {
@@ -252,7 +244,7 @@ class PgDocOp : public std::enable_shared_from_this<PgDocOp> {
   typedef std::unique_ptr<const PgDocOp> UniPtrConst;
 
   using Sender = std::function<Result<PgDocResponse>(
-      PgSession*, const PgsqlOpPtr*, size_t, const PgTableDesc&, uint64_t, bool)>;
+      PgSession*, const PgsqlOpPtr*, size_t, const PgTableDesc&, HybridTime, bool)>;
 
   // Constructors & Destructors.
   PgDocOp(
@@ -307,8 +299,6 @@ class PgDocOp : public std::enable_shared_from_this<PgDocOp> {
   const PgTable& table() const { return table_; }
 
  protected:
-  uint64_t& GetInTxnLimit();
-
   // Populate Protobuf requests using the collected information for this DocDB operator.
   virtual Result<bool> DoCreateRequests() = 0;
 
@@ -354,25 +344,13 @@ class PgDocOp : public std::enable_shared_from_this<PgDocOp> {
 
   static Result<PgDocResponse> DefaultSender(
       PgSession* session, const PgsqlOpPtr* ops, size_t ops_count, const PgTableDesc& table,
-      uint64_t in_txn_limit, bool force_non_bufferable);
+      HybridTime in_txn_limit, bool force_non_bufferable);
 
   //----------------------------------- Data Members -----------------------------------------------
  protected:
   // Session control.
   PgSession::ScopedRefPtr pg_session_;
 
-  // This time is set at the start (i.e., before sending the first batch of PgsqlOp ops) and must
-  // stay the same for the lifetime of the PgDocOp.
-  //
-  // Each query must only see data written by earlier queries in the same transaction, not data
-  // written by itself. Setting it at the start ensures that future operations of the PgDocOp only
-  // see data written by previous queries.
-  //
-  // NOTE: Each query might result in many PgDocOps. So using 1 in_txn_limit_ per PgDocOp is not
-  // enough. The same should be used across all PgDocOps in the query. This is ensured by the use
-  // of statement_in_txn_limit in yb_exec_params of EState.
-  uint64_t in_txn_limit_ = 0;
-
   // Target table.
   PgTable& table_;
 
@@ -457,11 +435,28 @@ class PgDocOp : public std::enable_shared_from_this<PgDocOp> {
   string out_param_backfill_spec_;
 
  private:
+  // Returns a reference to the in_txn_limit_ht to be used.
+  //
+  // For read ops: usually one in txn limit is chosen for all for read ops of a SQL statement. And
+  // the hybrid time in such a situation references the statement level integer that is passed down
+  // to all PgDocOp instances via PgExecParameters.
+  //
+  // In case the reference to the statement level in_txn_limit_ht isn't passed in PgExecParameters,
+  // the local in_txn_limit_ht_ is used which is 0 at the start of the PgDocOp.
+  //
+  // For writes: the local in_txn_limit_ht_ is used if available.
+  //
+  // See ReadHybridTimePB for more details about in_txn_limit.
+  uint64_t& GetInTxnLimitHt();
+
   // Result set either from selected or returned targets is cached in a list of strings.
   // Querying state variables.
   Status exec_status_ = Status::OK();
 
   Sender sender_;
+
+  // See ReadHybridTimePB for more details about in_txn_limit.
+  uint64_t in_txn_limit_ht_ = 0;
 };
 
 //--------------------------------------------------------------------------------------------------
diff --git a/src/yb/yql/pggate/pg_perform_future.cc b/src/yb/yql/pggate/pg_perform_future.cc
index a8f769021786..1f9c57ca611c 100644
--- a/src/yb/yql/pggate/pg_perform_future.cc
+++ b/src/yb/yql/pggate/pg_perform_future.cc
@@ -36,13 +36,15 @@ bool PerformFuture::Ready() const {
   return Valid() && future_.wait_for(0ms) == std::future_status::ready;
 }
 
-Result<rpc::CallResponsePtr> PerformFuture::Get() {
+Result<PerformFuture::Data> PerformFuture::Get() {
   PgSession* session = nullptr;
   std::swap(session, session_);
   auto result = future_.get();
   session->TrySetCatalogReadPoint(result.catalog_read_time);
   RETURN_NOT_OK(session->PatchStatus(result.status, relations_));
-  return result.response;
+  return Data{
+      .response = std::move(result.response),
+      .used_in_txn_limit = result.used_in_txn_limit};
 }
 
 } // namespace pggate
diff --git a/src/yb/yql/pggate/pg_perform_future.h b/src/yb/yql/pggate/pg_perform_future.h
index 165be465c884..9f6d25fdefcb 100644
--- a/src/yb/yql/pggate/pg_perform_future.h
+++ b/src/yb/yql/pggate/pg_perform_future.h
@@ -17,6 +17,7 @@
 #include <future>
 
 #include "yb/common/common_fwd.h"
+#include "yb/common/hybrid_time.h"
 
 #include "yb/util/status_fwd.h"
 
@@ -29,12 +30,17 @@ class PgSession;
 
 class PerformFuture {
  public:
+  struct Data {
+    rpc::CallResponsePtr response;
+    HybridTime used_in_txn_limit;
+  };
+
   PerformFuture() = default;
   PerformFuture(std::future<PerformResult> future, PgSession* session, PgObjectIds relations);
 
   bool Valid() const;
   bool Ready() const;
-  Result<rpc::CallResponsePtr> Get();
+  Result<Data> Get();
 
  private:
   std::future<PerformResult> future_;
diff --git a/src/yb/yql/pggate/pg_session.cc b/src/yb/yql/pggate/pg_session.cc
index 4e43423c4dd4..fac7b27e8979 100644
--- a/src/yb/yql/pggate/pg_session.cc
+++ b/src/yb/yql/pggate/pg_session.cc
@@ -36,6 +36,7 @@
 #include "yb/common/placement_info.h"
 #include "yb/common/ql_expr.h"
 #include "yb/common/ql_value.h"
+#include "yb/common/read_hybrid_time.h"
 #include "yb/common/row_mark.h"
 #include "yb/common/schema.h"
 #include "yb/common/transaction_error.h"
@@ -195,15 +196,37 @@ bool IsReadOnly(const PgsqlOp& op) {
 
 class PgSession::RunHelper {
  public:
-  RunHelper(PgSession* pg_session, SessionType session_type)
-      : pg_session_(*pg_session), session_type_(session_type) {
-  }
-
-  Status Apply(const PgTableDesc& table,
-                       const PgsqlOpPtr& op,
-                       uint64_t* in_txn_limit,
-                       bool force_non_bufferable) {
+  RunHelper(PgSession* pg_session, SessionType session_type, HybridTime in_txn_limit)
+      : pg_session_(*pg_session),
+        session_type_(session_type),
+        in_txn_limit_(in_txn_limit) {
+  }
+
+  Status Apply(const PgTableDesc& table, const PgsqlOpPtr& op, bool force_non_bufferable) {
+    // Refer src/yb/yql/pggate/README for details about buffering.
+    //
+    // TODO(#16261): Consider the following scenario:
+    // 1) A read op arrives here and adds itself to operations_.
+    // 2) Two write ops follow which change the same row and are added to operations_.
+    //    Should they not be flushed separately? (as per requirement 2b in the README)
+    //
+    // Moreover, consider a situation in which they are flushed separately, but the in_txn_limit
+    // picked might be incorrect:
+    // 1) A non-bufferable write op on key k1 enters Apply() and is flushed.
+    // 2) A read which has a preset in_txn_limit enters and is added to operations_. The
+    //    in_txn_limit happens to be smaller than the write time of the write op in (1).
+    // 3) Another write to key k1 is added to operations_. But it will end up using the preset
+    //    in_txn_limit. Isn't this incorrect?
+    //
+    // Both scenarios might not occur with any sort of SQL statement. But we should still try to
+    // find statements that can lead to this and fix these cases. Even if we don't find anything
+    // that leads to such scenarios, we should fix these anyway (unless we prove these scenarios
+    // can never occur).
+
+    VLOG(2) << "Apply " << (op->is_read() ? "read" : "write") << " op, table name: "
+            << table.table_name().table_name() << ", table id: " << table.id();
     auto& buffer = pg_session_.buffer_;
+
     // Try buffering this operation if it is a write operation, buffering is enabled and no
     // operations have been already applied to current session (yb session does not exist).
     if (operations_.empty() && pg_session_.buffering_enabled_ &&
@@ -221,12 +244,21 @@ class PgSession::RunHelper {
       SCHECK(operations_.empty(),
             IllegalState,
             "Buffered operations must be flushed before applying first non-bufferable operation");
-      // Buffered operations can't be combined within single RPC with non bufferable operation
-      // in case non bufferable operation has preset in_txn_limit.
-      // Buffered operations must be flushed independently in this case.
-      // Also operations for catalog session can be combined with buffered operations
-      // as catalog session is used for read-only operations.
-      if ((IsTransactional() && in_txn_limit && *in_txn_limit) || IsCatalog()) {
+      // Buffered write operations can't be combined within a single RPC with non-bufferable read
+      // operations in case the reads have a preset in_txn_limit. This is because as per requirement
+      // 1 and 2b) in README.txt, the writes and reads will require a different in_txn_limit. In
+      // case the in_txn_limit wasn't yet picked for the reads, they can be flushed together with
+      // the writes since both would use the current hybrid time as the in_txn_limit.
+      //
+      // Note however that the buffer has to be flushed before the non-buffered op if:
+      // 1) it is a non-buffered read that is on a table that is touched by the buffered writes
+      // 2) it is a non-buffered write that touches the same key as a buffered write
+      //
+      // Also operations for a catalog session are read-only operations. And "buffer" only buffers
+      // write operations. Since the writes and catalog reads belong to different session types (as
+      // per PgClientSession), we can't send them to the local tserver proxy in 1 rpc, so we flush
+      // the buffer before performing catalog reads.
+      if ((IsTransactional() && in_txn_limit_) || IsCatalog()) {
         RETURN_NOT_OK(buffer.Flush());
       } else {
         operations_ = VERIFY_RESULT(buffer.FlushTake(table, *op, IsTransactional()));
@@ -251,8 +283,7 @@ class PgSession::RunHelper {
           ? kHigherPriorityRange : kLowerPriorityRange;
     read_only = read_only && !IsValidRowMarkType(row_mark_type);
 
-    return pg_session_.pg_txn_manager_->CalculateIsolation(
-        read_only, txn_priority_requirement, in_txn_limit);
+    return pg_session_.pg_txn_manager_->CalculateIsolation(read_only, txn_priority_requirement);
   }
 
   Result<PerformFuture> Flush() {
@@ -261,7 +292,16 @@ class PgSession::RunHelper {
       return PerformFuture();
     }
 
-    return pg_session_.Perform(std::move(operations_), IsCatalog());
+    if (PREDICT_FALSE(yb_debug_log_docdb_requests)) {
+      LOG(INFO) << "Flushing collected operations, using session type: "
+                << ToString(session_type_) << " num ops: " << operations_.size();
+    }
+
+    return pg_session_.Perform(
+        std::move(operations_),
+        {.use_catalog_session = IsCatalog(),
+         .in_txn_limit = in_txn_limit_
+        });
   }
 
  private:
@@ -280,6 +320,7 @@ class PgSession::RunHelper {
   PgSession& pg_session_;
   const SessionType session_type_;
   BufferableOperations operations_;
+  const HybridTime in_txn_limit_;
 };
 
 //--------------------------------------------------------------------------------------------------
@@ -534,28 +575,22 @@ Result<PerformFuture> PgSession::FlushOperations(BufferableOperations ops, bool
       txn_priority_requirement = kHighestPriority;
     }
 
-    // Use 0 as the value of in_txn_limit to force setting current time as txn limit
-    uint64_t in_txn_limit = 0;
     RETURN_NOT_OK(pg_txn_manager_->CalculateIsolation(
-        false /* read_only */, txn_priority_requirement, &in_txn_limit));
+        false /* read_only */, txn_priority_requirement));
   }
 
   // In case of flushing of non-transactional operations it is required to set read time with the
   // very first (and all further) request as flushing is done asynchronously (i.e. YSQL may send
   // multiple bunch of operations in parallel). As a result PgClientService is unable to use read
   // time from remote t-server or generate its own.
-  const auto ensure_read_time_set_for_current_txn_serial_no = !transactional;
   return Perform(
-      std::move(ops), UseCatalogSession::kFalse, ensure_read_time_set_for_current_txn_serial_no);
+      std::move(ops), {.ensure_read_time_is_set = EnsureReadTimeIsSet(!transactional)});
 }
 
-Result<PerformFuture> PgSession::Perform(
-    BufferableOperations ops,
-    UseCatalogSession use_catalog_session,
-    bool ensure_read_time_set_for_current_txn_serial_no) {
+Result<PerformFuture> PgSession::Perform(BufferableOperations ops, PerformOptions&& ops_options) {
   DCHECK(!ops.empty());
   tserver::PgPerformOptionsPB options;
-  if (use_catalog_session) {
+  if (ops_options.use_catalog_session) {
     if (catalog_read_time_) {
       if (*catalog_read_time_) {
         catalog_read_time_->ToPB(options.mutable_read_time());
@@ -566,8 +601,10 @@ Result<PerformFuture> PgSession::Perform(
     options.set_use_catalog_session(true);
   } else {
     const auto txn_serial_no = pg_txn_manager_->SetupPerformOptions(&options);
-    ProcessPerformOnTxnSerialNo(
-        txn_serial_no, ensure_read_time_set_for_current_txn_serial_no, &options);
+    if (pg_txn_manager_->IsTxnInProgress()) {
+      options.mutable_in_txn_limit_ht()->set_value(ops_options.in_txn_limit.ToUint64());
+    }
+    ProcessPerformOnTxnSerialNo(txn_serial_no, ops_options.ensure_read_time_is_set, &options);
   }
   bool global_transaction = yb_force_global_transaction;
   for (auto i = ops.operations.begin(); !global_transaction && i != ops.operations.end(); ++i) {
@@ -790,14 +827,14 @@ Status PgSession::ValidatePlacement(const string& placement_info) {
 }
 
 Result<PerformFuture> PgSession::RunAsync(
-  const OperationGenerator& generator, uint64_t* in_txn_limit, bool force_non_bufferable) {
+    const OperationGenerator& generator, HybridTime in_txn_limit, bool force_non_bufferable) {
   auto table_op = generator();
   SCHECK(table_op.operation, IllegalState, "Operation list must not be empty");
   const auto* table = table_op.table;
   const auto* op = table_op.operation;
   const auto group_session_type = VERIFY_RESULT(GetRequiredSessionType(
       *pg_txn_manager_, *table, **op));
-  RunHelper runner(this, group_session_type);
+  RunHelper runner(this, group_session_type, in_txn_limit);
   const auto ddl_mode = pg_txn_manager_->IsDdlMode();
   for (; table_op.operation; table_op = generator()) {
     table = table_op.table;
@@ -809,7 +846,7 @@ Result<PerformFuture> PgSession::RunAsync(
               IllegalState,
               "Operations on different sessions can't be mixed");
     has_write_ops_in_ddl_mode_ = has_write_ops_in_ddl_mode_ || (ddl_mode && !IsReadOnly(**op));
-    RETURN_NOT_OK(runner.Apply(*table, *op, in_txn_limit, force_non_bufferable));
+    RETURN_NOT_OK(runner.Apply(*table, *op, force_non_bufferable));
   }
   return runner.Flush();
 }
diff --git a/src/yb/yql/pggate/pg_session.h b/src/yb/yql/pggate/pg_session.h
index 5d51b6f41926..64cf35b18db0 100644
--- a/src/yb/yql/pggate/pg_session.h
+++ b/src/yb/yql/pggate/pg_session.h
@@ -52,6 +52,7 @@ namespace pggate {
 YB_STRONGLY_TYPED_BOOL(OpBuffered);
 YB_STRONGLY_TYPED_BOOL(InvalidateOnPgClient);
 YB_STRONGLY_TYPED_BOOL(UseCatalogSession);
+YB_STRONGLY_TYPED_BOOL(EnsureReadTimeIsSet);
 
 class PgTxnManager;
 class PgSession;
@@ -227,8 +228,7 @@ class PgSession : public RefCountedThreadSafe<PgSession> {
   }
 
   Result<PerformFuture> RunAsync(
-      const OperationGenerator& generator, uint64_t* read_time,
-      bool force_non_bufferable);
+      const OperationGenerator& generator, HybridTime in_txn_limit, bool force_non_bufferable);
 
   // Smart driver functions.
   // -------------
@@ -329,9 +329,13 @@ class PgSession : public RefCountedThreadSafe<PgSession> {
 
   class RunHelper;
 
-  Result<PerformFuture> Perform(BufferableOperations ops,
-                                UseCatalogSession use_catalog_session,
-                                bool ensure_read_time_set_for_current_txn_serial_no = false);
+  struct PerformOptions {
+    UseCatalogSession use_catalog_session = UseCatalogSession::kFalse;
+    EnsureReadTimeIsSet ensure_read_time_is_set = EnsureReadTimeIsSet::kFalse;
+    HybridTime in_txn_limit = {};
+  };
+
+  Result<PerformFuture> Perform(BufferableOperations ops, PerformOptions&& options);
 
   void ProcessPerformOnTxnSerialNo(uint64_t txn_serial_no,
                                    bool force_set_read_time_for_current_txn_serial_no,
diff --git a/src/yb/yql/pggate/pg_sys_table_prefetcher.cc b/src/yb/yql/pggate/pg_sys_table_prefetcher.cc
index aef257062b60..8523e51e7099 100644
--- a/src/yb/yql/pggate/pg_sys_table_prefetcher.cc
+++ b/src/yb/yql/pggate/pg_sys_table_prefetcher.cc
@@ -295,14 +295,14 @@ class Loader {
             }
             return result;
           }),
-          nullptr /* read_time */, false /* force_non_bufferable */));
+          HybridTime() /* in_txn_limit */, false /* force_non_bufferable */));
       auto call_resp = VERIFY_RESULT(response.Get());
       Status remove_predicate_status;
       ResultFunctorAdapter<bool, OperationInfo&> remove_predicate(
           &remove_predicate_status,
           [&call_resp, data_container](OperationInfo& op_info) -> Result<bool> {
             auto& op = op_info.ReadOperation();
-            auto sidecar = VERIFY_RESULT(call_resp->GetSidecarHolder(
+            auto sidecar = VERIFY_RESULT(call_resp.response->GetSidecarHolder(
                 op.response()->rows_data_sidecar()));
             InsertData(data_container,
                        op_info.table->id(),
diff --git a/src/yb/yql/pggate/pg_txn_manager.cc b/src/yb/yql/pggate/pg_txn_manager.cc
index d66ab43dda0a..c4e317789134 100644
--- a/src/yb/yql/pggate/pg_txn_manager.cc
+++ b/src/yb/yql/pggate/pg_txn_manager.cc
@@ -250,23 +250,13 @@ uint64_t PgTxnManager::NewPriority(TxnPriorityRequirement txn_priority_requireme
                           txn_priority_regular_upper_bound);
 }
 
-Status PgTxnManager::CalculateIsolation(bool read_only_op,
-                                        TxnPriorityRequirement txn_priority_requirement,
-                                        uint64_t* in_txn_limit) {
+Status PgTxnManager::CalculateIsolation(
+    bool read_only_op, TxnPriorityRequirement txn_priority_requirement) {
   if (ddl_mode_) {
     VLOG_TXN_STATE(2);
     return Status::OK();
   }
 
-  auto se = ScopeExit([this, in_txn_limit] {
-    if (in_txn_limit) {
-      if (!*in_txn_limit) {
-        *in_txn_limit = clock_->Now().ToUint64();
-      }
-      in_txn_limit_ = HybridTime(*in_txn_limit);
-    }
-  });
-
   VLOG_TXN_STATE(2);
   if (!txn_in_progress_) {
     return RecreateTransaction(SavePriority::kFalse);
@@ -384,7 +374,6 @@ void PgTxnManager::ResetTxnAndSession() {
   txn_in_progress_ = false;
   isolation_level_ = IsolationLevel::NON_TRANSACTIONAL;
   priority_ = 0;
-  in_txn_limit_ = HybridTime();
   ++txn_serial_no_;
 
   enable_follower_reads_ = false;
@@ -430,9 +419,6 @@ uint64_t PgTxnManager::SetupPerformOptions(tserver::PgPerformOptionsPB* options)
   options->set_isolation(isolation_level_);
   options->set_ddl_mode(ddl_mode_);
   options->set_txn_serial_no(txn_serial_no_);
-  if (txn_in_progress_ && in_txn_limit_) {
-    options->set_in_txn_limit_ht(in_txn_limit_.ToUint64());
-  }
   if (use_saved_priority_) {
     options->set_use_existing_priority(true);
   } else {
diff --git a/src/yb/yql/pggate/pg_txn_manager.h b/src/yb/yql/pggate/pg_txn_manager.h
index d6b479a73d4a..39a0f3225055 100644
--- a/src/yb/yql/pggate/pg_txn_manager.h
+++ b/src/yb/yql/pggate/pg_txn_manager.h
@@ -57,9 +57,7 @@ class PgTxnManager : public RefCountedThreadSafe<PgTxnManager> {
   virtual ~PgTxnManager();
 
   Status BeginTransaction();
-  Status CalculateIsolation(bool read_only_op,
-                                    TxnPriorityRequirement txn_priority_requirement,
-                                    uint64_t* in_txn_limit = nullptr);
+  Status CalculateIsolation(bool read_only_op, TxnPriorityRequirement txn_priority_requirement);
   Status RecreateTransaction();
   Status RestartTransaction();
   Status ResetTransactionReadPoint();
@@ -127,7 +125,6 @@ class PgTxnManager : public RefCountedThreadSafe<PgTxnManager> {
   // and cancels the other transaction.
   uint64_t priority_ = 0;
   SavePriority use_saved_priority_ = SavePriority::kFalse;
-  HybridTime in_txn_limit_;
 
   std::unique_ptr<tserver::TabletServerServiceProxy> tablet_server_proxy_;
 
diff --git a/src/yb/yql/pggate/pggate.cc b/src/yb/yql/pggate/pggate.cc
index 83deb9e22d83..1a5637d93022 100644
--- a/src/yb/yql/pggate/pggate.cc
+++ b/src/yb/yql/pggate/pggate.cc
@@ -190,21 +190,22 @@ class PrecastRequestSender {
  public:
   Result<PgDocResponse> Send(
       PgSession* session, const PgsqlOpPtr* ops, size_t ops_count, const PgTableDesc& table,
-      uint64_t in_txn_limit, bool force_non_bufferable) {
+      HybridTime in_txn_limit, bool force_non_bufferable) {
     if (!collecting_mode_) {
       auto future = VERIFY_RESULT(session->RunAsync(
-          ops, ops_count, table, &in_txn_limit, force_non_bufferable));
-      return PgDocResponse(std::move(future), in_txn_limit);
+          ops, ops_count, table, in_txn_limit, force_non_bufferable));
+      return PgDocResponse(std::move(future));
     }
-    // For now PrecastRequestSender can work with zero in txn limit only.
-    // Zero read time means that current time should be used as in txn limit.
-    RSTATUS_DCHECK(!in_txn_limit, IllegalState, "Only zero read time is expected");
+    // For now PrecastRequestSender can work only with a new in txn limit set to the current time
+    // for each batch of ops. It doesn't use a single in txn limit for all read ops in a statement.
+    // TODO: Expalin why is this the case because it differs from requirement 1 in
+    // src/yb/yql/pggate/README
+    RSTATUS_DCHECK(!in_txn_limit, IllegalState, "Only zero is expected");
     for (auto end = ops + ops_count; ops != end; ++ops) {
       ops_.emplace_back(*ops, table);
     }
     if (!provider_state_) {
-      provider_state_ = std::make_shared<ResponseProvider::State>(
-          rpc::CallResponsePtr(), 0 /* in_txn_limit */);
+      provider_state_ = std::make_shared<ResponseProvider::State>();
     }
     return PgDocResponse(std::make_unique<ResponseProvider>(provider_state_));
   }
@@ -231,8 +232,8 @@ class PrecastRequestSender {
           }
           auto& info = *i++;
           return PgSession::TableOperation{.operation = &info.operation, .table = info.table};
-        }), &provider_state_->in_txn_limit, false /* force_non_bufferable */));
-    provider_state_->response = VERIFY_RESULT(perform_future.Get());
+        }), HybridTime(), false /* force_non_bufferable */));
+    *provider_state_ = VERIFY_RESULT(perform_future.Get());
     return Status::OK();
   }
 
@@ -256,7 +257,7 @@ Status FetchExistingYbctids(PgSession::ScopedRefPtr session,
   boost::container::small_vector<std::unique_ptr<PgDocReadOp>, 16> doc_ops;
   auto request_sender = [&precast_sender](
       PgSession* session, const PgsqlOpPtr* ops, size_t ops_count, const PgTableDesc& table,
-      uint64_t in_txn_limit, bool force_non_bufferable) {
+      HybridTime in_txn_limit, bool force_non_bufferable) {
     return precast_sender.Send(session, ops, ops_count, table, in_txn_limit, force_non_bufferable);
   };
   // Start all the doc_ops to read from docdb in parallel, one doc_op per table ID.
diff --git a/src/yb/yql/pggate/ybc_pg_typedefs.h b/src/yb/yql/pggate/ybc_pg_typedefs.h
index 3902fbfc8d8e..c8e6f95a25b8 100644
--- a/src/yb/yql/pggate/ybc_pg_typedefs.h
+++ b/src/yb/yql/pggate/ybc_pg_typedefs.h
@@ -296,7 +296,7 @@ typedef struct PgExecParameters {
   int wait_policy = 2; // Cast to yb::WaitPolicy for C++ use. (2 is for yb::WAIT_ERROR)
   char *bfinstr = NULL;
   uint64_t backfill_read_time = 0;
-  uint64_t* statement_in_txn_limit = NULL;
+  uint64_t* stmt_in_txn_limit_ht_for_reads = NULL;
   char *partition_key = NULL;
   PgExecOutParam *out_param = NULL;
   bool is_index_backfill = false;
@@ -308,7 +308,7 @@ typedef struct PgExecParameters {
   int wait_policy; // Cast to LockWaitPolicy for C use
   char *bfinstr;
   uint64_t backfill_read_time;
-  uint64_t* statement_in_txn_limit;
+  uint64_t* stmt_in_txn_limit_ht_for_reads;
   char *partition_key;
   PgExecOutParam *out_param;
   bool is_index_backfill;
diff --git a/src/yb/yql/pggate/ybc_pggate.cc b/src/yb/yql/pggate/ybc_pggate.cc
index d62554fc260c..11a11e0b4be3 100644
--- a/src/yb/yql/pggate/ybc_pggate.cc
+++ b/src/yb/yql/pggate/ybc_pggate.cc
@@ -34,6 +34,8 @@
 #include "yb/util/thread.h"
 #include "yb/util/yb_partition.h"
 
+#include "yb/server/skewed_clock.h"
+
 #include "yb/yql/pggate/pg_env.h"
 #include "yb/yql/pggate/pg_expr.h"
 #include "yb/yql/pggate/pg_gate_fwd.h"
@@ -117,6 +119,11 @@ Slice YbctidAsSlice(uint64_t ybctid) {
 
 void YBCInitPgGateEx(const YBCPgTypeEntity *data_type_table, int count, PgCallbacks pg_callbacks,
                      PgApiContext* context) {
+  // TODO: We should get rid of hybrid clock usage in YSQL backend processes (see #16034).
+  // However, this is added to allow simulating and testing of some known bugs until we remove
+  // HybridClock usage.
+  server::SkewedClock::Register();
+
   InitThreading();
 
   CHECK(pgapi == nullptr) << ": " << __PRETTY_FUNCTION__ << " can only be called once";
diff --git a/src/yb/yql/pgwrapper/CMakeLists.txt b/src/yb/yql/pgwrapper/CMakeLists.txt
index ea432c36945f..72604849f504 100644
--- a/src/yb/yql/pgwrapper/CMakeLists.txt
+++ b/src/yb/yql/pgwrapper/CMakeLists.txt
@@ -89,6 +89,7 @@ ADD_YB_LIBRARY(ysql_upgrade
 set(YB_TEST_LINK_LIBS yb_pgwrapper yb_client ql-dml-test-base pg_wrapper_test_base tools_test_utils
     geo_transactions_test_base ${YB_MIN_TEST_LIBS})
 ADD_YB_TEST(pg_catalog_perf-test)
+ADD_YB_TEST(pg_clock_skew-test)
 ADD_YB_TEST(pg_ddl_concurrency-test)
 ADD_YB_TEST(pg_fkey-test)
 ADD_YB_TEST(pg_gin_index-test)
diff --git a/src/yb/yql/pgwrapper/pg_clock_skew-test.cc b/src/yb/yql/pgwrapper/pg_clock_skew-test.cc
new file mode 100644
index 000000000000..b9968647c39f
--- /dev/null
+++ b/src/yb/yql/pgwrapper/pg_clock_skew-test.cc
@@ -0,0 +1,89 @@
+// Copyright (c) YugaByte, Inc.
+//
+// Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
+// in compliance with the License.  You may obtain a copy of the License at
+//
+// http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software distributed under the License
+// is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
+// or implied.  See the License for the specific language governing permissions and limitations
+// under the License.
+
+#include <string>
+
+#include "yb/server/skewed_clock.h"
+
+#include "yb/util/format.h"
+
+#include "yb/yql/pgwrapper/libpq_test_base.h"
+
+namespace yb {
+namespace pgwrapper {
+namespace {
+
+class PgClockSkewTest : public LibPqTestBase {
+ private:
+  int GetNumTabletServers() const override {
+    return 3;
+  }
+
+  void UpdateMiniClusterOptions(ExternalMiniClusterOptions* opts) override {
+    LibPqTestBase::UpdateMiniClusterOptions(opts);
+    auto time_source_flag = Format("--time_source=$0,$${index}99", server::SkewedClock::kName);
+    opts->extra_tserver_flags.push_back(time_source_flag);
+    opts->extra_master_flags.push_back(time_source_flag);
+  }
+};
+
+} // namespace
+
+TEST_F(PgClockSkewTest, InTxnLimitBug) {
+  // This test case is inspired from #15933 which is in turn caused due to #16034.
+  //
+  // In a nutshell, the bug arises in the following scenario:
+  // 1) Assume there are 3 tservers N1, N2 and N3 with clock skews +99ms, +199ms and +299ms.
+  // 2) The client connects to N1 and DELETEs a row which resides on N2. The write time of the
+  //    DELETE is picked on N2, say it is X.
+  // 3) The client then issues an INSERT of the same row and N1 picks an in_txn_limit using the
+  //    current time for this operation. Refer ReadHybridTimePB for semantics of in_txn_limit. But Y
+  //    might be less than X because N1's clock lags behind N2.
+  // 4) This will result in a situation where the DELETE isn't visible to the INSERT. This will lead
+  //    to a spurious duplicate key error.
+  //
+  // The situation where Y is less than X should occur even if clock skew exists. This is ensured by
+  // propagation of hybrid times across nodes in all rpcs which guarantees hybrid time monotonicity
+  // in a causal chains of events.
+  auto conn = ASSERT_RESULT(Connect());
+  ASSERT_OK(conn.Execute("CREATE TABLE test (k int primary key, v int)"));
+  ASSERT_OK(conn.Execute("CREATE UNIQUE INDEX test_value_key1 ON test USING lsm (v HASH)"));
+  ASSERT_OK(conn.Execute("INSERT INTO test SELECT s, s from generate_series(1, 10) as s"));
+  for (size_t i = 1; i <= 10; ++i) {
+    // This UPDATE will result in a DELETE + INSERT on the same index key v1=2, which would
+    // trigger the bug seen in #15933 -- i.e., the INSERT wouldn't see the data written by the
+    // DELETE and hence throw a duplicate key constraint violation.
+    ASSERT_OK(conn.ExecuteFormat("UPDATE test SET v = $0 WHERE k = $0", i));
+  }
+
+  // The same bug as seen in #15933 can be seen on a main table with a simple DELETE + INSERT.
+  ASSERT_OK(conn.Execute("DROP INDEX test_value_key1"));
+  for (size_t i = 1; i <= 10; ++i) {
+    ASSERT_OK(conn.Execute("BEGIN TRANSACTION ISOLATION LEVEL REPEATABLE READ"));
+    ASSERT_OK(conn.ExecuteFormat("DELETE FROM test WHERE k = $0", i));
+    ASSERT_OK(conn.ExecuteFormat("INSERT INTO test VALUES ($0, $0)", i));
+    ASSERT_OK(conn.Execute("COMMIT"));
+  }
+
+  // Try an INSERT followed by INSERT to ensure that the second insert is able to see the first
+  // and fails with a duplicate key error.
+  ASSERT_OK(conn.Execute("TRUNCATE test"));
+  for (size_t i = 1; i <= 10; ++i) {
+    ASSERT_OK(conn.Execute("BEGIN TRANSACTION ISOLATION LEVEL REPEATABLE READ"));
+    ASSERT_OK(conn.ExecuteFormat("INSERT INTO test VALUES ($0, $0)", i));
+    ASSERT_NOK(conn.ExecuteFormat("INSERT INTO test VALUES ($0, $0)", i));
+    ASSERT_OK(conn.Execute("ROLLBACK"));
+  }
+}
+
+} // namespace pgwrapper
+} // namespace yb
